﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using Telerik.Web.UI;

public partial class Default : System.Web.UI.Page
{
	public class OneInstallationOneDayRow
	{
		public int AssetTypeId { get; set; }

		public int DeviceCount { get; set; }

		public string DeviceStatus { get; set; }

		public int InstallationId { get; set; }

		public DateTime ReportDate { get; set; }

		public int StatusId { get; set; }
	}

	protected void Page_Load(object sender, EventArgs e)
	{
		this.BindData(this.BuildData());
	}
	private void BindData(IEnumerable<OneInstallationOneDayRow> Items)
	{
		Decimal Sum = Items.Sum(r => r.DeviceCount);
		PieSeries PS = new PieSeries();
		PS.StartAngle = 90;
		PS.LabelsAppearance.Position = Telerik.Web.UI.HtmlChart.PieAndDonutLabelsPosition.OutsideEnd;
		PS.LabelsAppearance.DataFormatString = "{0:P2}";
		PS.TooltipsAppearance.DataFormatString = "{0:P2}";
		foreach (OneInstallationOneDayRow Row in Items)
		{
			if (Row.DeviceCount > 0)
			{
				//PS.Items.Add(new SeriesItem()
				//{
				//	BackgroundColor = this.GetColor(Row.StatusId),
				//	Name = Row.DeviceStatus,
				//	YValue = (Decimal)Row.DeviceCount / Sum,
				//	Exploded = true
				//});
				PS.SeriesItems.Add(new PieSeriesItem()
				{
					BackgroundColor = this.GetColor(Row.StatusId),
					Name = Row.DeviceStatus,
					Y = (Decimal)Row.DeviceCount / Sum,
					Exploded = true
				});
			}
		} this.RadHtmlChart1.PlotArea.Series.Add(PS);
	}
	private List<OneInstallationOneDayRow> BuildData()
	{
		List<OneInstallationOneDayRow> Entries = new List<OneInstallationOneDayRow>(); for (int i = 0; i < 9; i++)
		{
			Entries.Add(new OneInstallationOneDayRow()
			{
				AssetTypeId = 1,
				DeviceCount = i * 10,
				DeviceStatus = this.GetStatus(i),
				InstallationId = 4,
				ReportDate = DateTime.Today,
				StatusId = i
			});
		} return Entries;
	}
	private String GetStatus(Int32 StatusId)
	{
		switch (StatusId)
		{
			case 2:
				return "Warnings";
			case 3:
				return "Fixture Malfunction";
			case 4:
				return "No Comm";
			case 5:
				return "Extended No Comm";
			case 6:
				return "Partial Report";
			case 7:
				return "Unregistered";
			case 8:
				return "No Power";
			default:
				return "Normal";
		}
	}
	private Color GetColor(Int32 StatusId)
	{
		switch (StatusId)
		{
			case 2:
				return Color.Yellow;
			case 3:
				return Color.Crimson;
			case 4:
				return Color.DarkBlue;
			case 5:
				return Color.Red;
			case 6:
				return Color.Pink;
			case 7:
				return Color.Wheat;
			case 8:
				return Color.Turquoise;
			default:
				return Color.LightGreen;
		}
	}
}